// COMTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

// Include com api
#include <objbase.h>

// Include interface (That's all we need. COM needs no libs :)
#include "..\include\icoolrender.h"

// Create usefull release macro
#define COM_SAFE_RELEASE(x) if (x != NULL) x->Release(); x = NULL

// Create cool render pointer
ICoolRender * pAnyRender = NULL;

int main(int argc, char* argv[])
{
	
	// Initialize COM
	CoInitialize(NULL);
	
	// First try the DirectX8 render
	if (FAILED(GetDirectX8Render(pAnyRender)))
	{
		MessageBox(NULL, "Make sure DirectX8 render component is installed", "ERROR!", MB_ICONERROR|MB_OK);
		return 1;
	}

	// Run function
	pAnyRender->DoCool3DGame();

	// Relase again. This is important or COM component won't get unloaded!
	COM_SAFE_RELEASE(pAnyRender);

	// Try OpenGL render
	if (FAILED(GetOpenGLRender(pAnyRender)))
	{
		MessageBox(NULL, "Make sure OpenGL render component is installed", "ERROR!", MB_ICONERROR|MB_OK);
		return 1;
	}

	// Run function
	pAnyRender->DoCool3DGame();

	// Relase again. This is important or COM component won't get unloaded!
	COM_SAFE_RELEASE(pAnyRender);
	
	// Release COM
	CoUninitialize();
	
	return 0;
}
